//---------------------------------------------------------------------------
//
//                     КЛОЧКОВ ПАВЕЛ
//             http://www.interestprograms.ru
//---------------------------------------------------------------------------

// MFCTestDlg.cpp : implementation file
//

#include "stdafx.h"
#include "MFCTest.h"
#include "MFCTestDlg.h"

#include "storage.h"
#include ".\mfctestdlg.h"
#include <Mmsystem.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CMFCTestDlg dialog



GdiplusStartupInput gdiplusStartupInput;
ULONG_PTR           gdiplusToken;




CMFCTestDlg::CMFCTestDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMFCTestDlg::IDD, pParent)
	, m_pStream(NULL)
	, m_pPicture(NULL)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

	GdiplusStartup(&gdiplusToken, &gdiplusStartupInput, NULL);
}
CMFCTestDlg::~CMFCTestDlg()
{
	GdiplusShutdown(gdiplusToken);
}

void CMFCTestDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CMFCTestDlg, CDialog)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_BUTTON1, OnBnClickedButton1)
END_MESSAGE_MAP()


// CMFCTestDlg message handlers

BOOL CMFCTestDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here

	
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CMFCTestDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CPaintDC dc(this);

		RECT rc;

		if(m_pStream != NULL){
			// прорисовка изображения с помощью GDI
			GetDlgItem(IDC_STATICIMAGE2)->GetClientRect(&rc);
			CDC* pDC = GetDlgItem(IDC_STATICIMAGE2)->GetDC();
			DrawImage( pDC->GetSafeHdc(), rc);
			GetDlgItem(IDC_STATICIMAGE2)->ReleaseDC(pDC);
			


			// прорисовка изображения с использованием  GDI+
			Graphics g(  GetDlgItem(IDC_STATICIMAGE)->m_hWnd );
			GetDlgItem(IDC_STATICIMAGE)->GetClientRect(&rc);
			Image* image = Image::FromStream(m_pStream);
			g.DrawImage(image, rc.left, rc.top, rc.right - rc.left, rc.bottom - rc.top );
		}

		//CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CMFCTestDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void CMFCTestDlg::OnBnClickedButton1()
{
	// счетчик потоков (одновременно их имя)
	static numberstream = 0;

	// можете в составной файл добавлять любое количество потоков картинок и текста
	// эта переменная будет следить когда переключаться на начало просмотра
	bool again = true;

	IStorage* pStorage    = NULL;
	IStorage* psubStorage = NULL;
	IStream* pStream      = NULL;

	CString pathmain = "test", namestream;
	namestream.Format("%d", numberstream );

	HRESULT hr = StgOpenStorage( pathmain.AllocSysString(), NULL, STGM_READ | STGM_SHARE_EXCLUSIVE, 0,0, &pStorage);
	if(hr == S_OK){
		// открываем потоки картинок
		hr = pStorage->OpenStream(namestream.AllocSysString(), NULL, STGM_READ | STGM_SHARE_EXCLUSIVE, 0, &pStream);
		if(hr == S_OK){
			STATSTG statstg;
			hr = pStream->Stat(&statstg, STATFLAG_NONAME);
			if(hr == S_OK){
				HGLOBAL hMem  = GlobalAlloc( GHND, statstg.cbSize.QuadPart);
				if(hMem != NULL){
					LPVOID memory = GlobalLock(hMem);
					pStream->Read(memory, statstg.cbSize.QuadPart, 0);
					GlobalUnlock(hMem);
					hr = CreateStreamOnHGlobal(hMem, FALSE, &m_pStream);
					if(hr == S_OK){
						// для использования "обычного "GDI
						LoadImageFromStream(m_pStream);
						again = false;
						numberstream++;
					}

				}// if(hMem != NULL){
			}
			if(pStream != NULL){
				pStream->Release();
				pStream = NULL;
			}
			// открываем текстовые потоки
			CString namesubstorage = "text";
			hr = pStorage->OpenStorage(namesubstorage.AllocSysString(), NULL, STGM_READ | STGM_SHARE_EXCLUSIVE, 0, 0, &psubStorage); 
			if(hr == S_OK){
				hr = psubStorage->OpenStream(namestream.AllocSysString(), NULL, STGM_READ | STGM_SHARE_EXCLUSIVE, 0, &pStream);
				if(hr == S_OK){
					STATSTG statstg;
					hr = pStream->Stat(&statstg, STATFLAG_NONAME);
					if(hr == S_OK){
						HGLOBAL hMem  = GlobalAlloc( GHND, statstg.cbSize.QuadPart);
						if(hMem != NULL){
							TCHAR* pTCHAR = new TCHAR[statstg.cbSize.QuadPart+1];
							if(pTCHAR != NULL){
								LPVOID memory = GlobalLock(hMem);
								hr =pStream->Read(memory, statstg.cbSize.QuadPart, 0);
								if(hr == S_OK){
									CopyMemory(pTCHAR, memory, statstg.cbSize.QuadPart);
									pTCHAR[statstg.cbSize.QuadPart] = '\0';
									GlobalUnlock(hMem);
									GlobalFree(hMem);
									GetDlgItem(IDC_STATICTEXT)->SetWindowText(pTCHAR);
									delete pTCHAR;
								}
							}
						}
					}
					if(pStream != NULL){
						pStream->Release();
						pStream = NULL;
					}
				}// if(hr == S_OK){ hr = psubStorage->OpenStream(namestre 
			}// if(hr == S_OK){ hr = pStorage->OpenStorage(namesu
		//----------------------------------------------------------------------------------------
			{
			// открываем звуковые потоки
			CString namesubstorage = "звук";
			hr = pStorage->OpenStorage(namesubstorage.AllocSysString(), NULL, STGM_READ | STGM_SHARE_EXCLUSIVE, 0, 0, &psubStorage); 
			if(hr == S_OK){
				hr = psubStorage->OpenStream(namestream.AllocSysString(), NULL, STGM_READ | STGM_SHARE_EXCLUSIVE, 0, &pStream);
				if(hr == S_OK){
					STATSTG statstg;
					hr = pStream->Stat(&statstg, STATFLAG_NONAME);
					if(hr == S_OK){
						HGLOBAL hMem  = GlobalAlloc( GHND, statstg.cbSize.QuadPart);
						if(hMem != NULL){
								LPVOID memory = GlobalLock(hMem);
								hr =pStream->Read(memory, statstg.cbSize.QuadPart, 0);
								if(hr == S_OK){
									PlaySound( (LPCTSTR)memory, NULL, SND_MEMORY|SND_ASYNC);
									GlobalUnlock(hMem);
									//GlobalFree(hMem);
							
							}
						}
					}
					if(pStream != NULL){
						pStream->Release();
						pStream = NULL;
					}
				}// if(hr == S_OK){ hr = psubStorage->OpenStream(namestre 
			}// if(hr == S_OK){ hr = pStorage->OpenStorage(namesu
			}
		//------------------------------------------------------------------------------------------
		}
		if(pStorage != NULL)
			pStorage->Release();
	}
	else{
		AfxMessageBox("Файл \"test\" отсутствует или поврежден!\nНа www.interestprograms.ru  вы найдете действующий пример.");
	}

	if(again == true)
		numberstream = 0;

	

	CRect rc;
	rc.SetRect(0,0,1,1);
	InvalidateRect(&rc);

}


HRESULT CMFCTestDlg::LoadImageFromStream(IStream* pStream)
{
	HRESULT hr = E_NOTIMPL;
	hr = ::OleLoadPicture(pStream, 0, TRUE, IID_IPicture, (void**)&m_pPicture);

	return hr;

}

HRESULT CMFCTestDlg::DrawImage(HDC hdc, const RECT& rc)
{
	HRESULT hr = E_UNEXPECTED;
	if (m_pPicture != NULL){
		// получаем ширину и высоту изображения
		long hmWidth = 0, hmHeight = 0;
		m_pPicture->get_Width(&hmWidth);
		m_pPicture->get_Height(&hmHeight);

		hr = m_pPicture->Render(
			hdc,					// контекст в котором будем рисовать
			rc.left,				// координата left рисуемого изображения в контесте
			rc.top,					// координата top  рисуемого изображения в контесте
			rc.right  - rc.left,	// ширина рисуемого изображения
			rc.bottom - rc.top,		// высота рисуемого изображения
			0,						// горизонтальное смещение исходного изображения
			hmHeight,				// вертикальное смещение исходного изображения
			hmWidth,		        // сжатие и растяжение в горизонтальном измерении
			-hmHeight,				// сжатие и растяжение в вертикальном измерении		
			NULL	/*&rc*/		    // прямоугольник раположения изображения если hdc принадлежит метафайлу
			);
	}

	return hr;
}
